-module(ebb_loop).
-export([loopback/1, state/2]).

loopback(Op) ->
    N = flow_graph:in_arity(Op),
    Block = lists:duplicate(N,0),
    Pass = lists:seq(2,N+1),
    flow_graph:loop(
      ebb_prim:id(N),
      flow_graph:pipe(
	[Op,
	 flow_graph:split(N+1),
	 flow_graph:switch(
	   flow_graph:route(N+1, [1]),
	   [{loop, flow_graph:route(N+1, lists:append(Block,Pass))},
	    {stop, flow_graph:route(N+1, lists:append(Pass,Block))}])])).

state(Init, Op) ->
    flow_graph:loop(Init, Op).
